
CREATE DATABASE Tracking;
USE Tracking;

CREATE TABLE dispositivi (
  codice_accesso char(32) NOT NULL,
  username varchar(16) NOT NULL,
  random integer NOT NULL,
  PRIMARY KEY (codice_accesso),
  UNIQUE KEY username_UNIQUE(username)
);

CREATE TABLE posizioni (
  dispositivo char(32) NOT NULL,
  timestamp datetime NOT NULL,
  latitudine double NOT NULL,
  longitudine double NOT NULL,
  PRIMARY KEY (dispositivo, timestamp),
  KEY dispositivo_index(dispositivo),
  FOREIGN KEY (dispositivo) REFERENCES dispositivi(codice_accesso)
);

CREATE TABLE utenti (
  username varchar(16) NOT NULL,
  password varchar(16) NOT NULL,
  PRIMARY KEY (username)
);
