
import java.sql.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class TrackingService extends HttpServlet {

    private Connection tracking;
    final private String dbms_url = "jdbc:mysql://127.0.0.1:3306/";
    final private String database = "Tracking";
    final private String user = "root";
    final private String password = "";
    final private String driver = "com.mysql.jdbc.Driver";
    private boolean connected;

    public void init() {
        System.out.println("INIT");
        String url = dbms_url+database;
        try {
            Class.forName(driver);
            tracking = DriverManager.getConnection(url, user, password);
            connected = true;
        }
        catch (SQLException e) {
            connected = false;
        }
        catch (ClassNotFoundException e) {
            connected = false;
        }
    }
    
    public void destroy() {
        System.out.println("DESTROY");
        try {
            tracking.close();
        }
        catch (SQLException e) {
        }
    }
    
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        PrintWriter out;
        String url = request.getRequestURL().toString();
        String format = request.getParameter("format");
        String username = request.getParameter("username");
        String password = request.getParameter("password");
        //String dispositivo;
        int start, stop;
        Statement stat;
        ResultSet result;
                
        System.out.println("GET");
        if (!connected) {
            response.sendError(500, "DBMS server error!");
            return;
        }
        if (format == null) {
            response.sendError(400, "Wrong or missing parameters!");
            return;
        }
        if (format.isEmpty()) {
            response.sendError(400, "Wrong or missing parameters!");
            return;
        }
        if (!(format.equalsIgnoreCase("XML"))) {
            response.sendError(400, "Wrong or missing parameters!");
            return;
        }
        if (username == null || password == null) {
            response.sendError(400, "Wrong or missing authentication data!");
            return;
        }
        if (username.isEmpty() || password.isEmpty()) {
            response.sendError(400, "Wrong or missing authentication data!");
            return;
        }
        try {
            stat = tracking.createStatement();
            result = stat.executeQuery("SELECT password FROM utenti WHERE username='" + username + "';");
            if (result.next()) {
                if (!password.equals(result.getString(1))) {
                    response.sendError(401, "Wrong username and/or password!");
                    result.close();
                    stat.close();
                    return;
                }
            }
            else {
                response.sendError(401, "Wrong username and/or password!");
                result.close();
                stat.close();
                return;
            }
        }
        catch (SQLException e) {
            response.sendError(500, "DBMS server error!");
        }
        
        if (url.endsWith("one") || url.endsWith("ONE") || url.endsWith("One")) {
            String user = request.getParameter("user");
            if (user == null) {
                response.sendError(400, "Wrong or missing parameters!");
                return;
            }
            if (user.isEmpty()) {
                response.sendError(400, "Wrong or missing parameters!");
                return;
            }
            try {
                stat = tracking.createStatement();
                result = stat.executeQuery("SELECT codice_accesso FROM dispositivi WHERE username='" + user + "';");
                if (result.next()) {
                    dispositivo = result.getString(1);
                }
                else {
                    response.sendError(404, "User not found!");
                    result.close();
                    stat.close();
                    return;
                }
                response.setContentType("text/xml;charset=UTF-8");
                out = response.getWriter();
                out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
                out.println("<track-data>");
                out.print("<device code = \""+ dispositivo + "\">");
                out.print("<user>" + user + "</user>");
                String query = "SELECT timestamp, latitudine, longitudine FROM posizioni WHERE dispositivo ='" + dispositivo + "';";
                result = stat.executeQuery(query);
                while (result.next()) {
                    out.print("<position>");
                    out.print("<timestamp>" + result.getString(1) + "</timestamp>");
                    out.print("<latitude>" + result.getString(2) + "</latitude>");
                    out.print("<longitude>" + result.getString(3) + "</longitude>");
                    out.print("</position>");
                }
                out.println("</device>");
                out.println("</track-data>");
                result.close();
                stat.close();
                out.close();
                response.setStatus(200); // OK
            }
            catch (SQLException e) {
                response.sendError(500, "DBMS server error!");
            }
        }
        else {
            if (url.endsWith("all") || url.endsWith("ALL") || url.endsWith("All")) {
                try {
                    stat = tracking.createStatement();
                    String query = "SELECT username, dispositivo, timestamp, latitudine, longitudine FROM dispositivi AS DEV, posizioni WHERE codice_accesso = dispositivo AND timestamp >= (SELECT MAX(timestamp) FROM posizioni WHERE dispositivo = DEV.codice_accesso);"; // ultima posizione rilevata negli ultimi 60 secondi
                    result = stat.executeQuery(query);
                    response.setContentType("text/xml;charset=UTF-8");
                    out = response.getWriter();
                    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
                    out.println("<last-data>");
                    while (result.next()) {
                        out.print("<device code = \""+ result.getString(2) + "\">");
                        out.print("<user>" + result.getString(1) + "</user>");
                        out.print("<position>");
                        out.print("<timestamp>" + result.getString(3) + "</timestamp>");
                        out.print("<latitude>" + result.getString(4) + "</latitude>");
                        out.print("<longitude>" + result.getString(5) + "</longitude>");
                        out.print("</position>");
                        out.println("</device>");
                    }
                out.println("</last-data>");
                result.close();
                stat.close();
                out.close();
                response.setStatus(200); // OK
                }
                catch (SQLException e) {
                    response.sendError(500, "DBMS server error!");
                }
            }
            else {
                response.sendError(400, "Wrong request!");
            }
        }
    }
    
    public String getServletInfo() {
        return "Tracking service";
    }
}
