package com.zanichelli.android.geotracker;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

public class UDPThread extends Thread {
  private byte[] message;
  private String server;
  private int serverPort;

  // costruttore: la stringa è il messaggio da inviare via UDP
  public UDPThread(byte[] message, String server, int serverPort) {
    this.message = message;
    this.server = server;
    this.serverPort = serverPort;
  }

  @Override
  public void run() {
    try {
      DatagramSocket socket = new DatagramSocket();
      InetAddress serverAddress = InetAddress.getByName(server);

      DatagramPacket packet = new DatagramPacket(message,
        message.length,
        serverAddress,
        serverPort);

      socket.send(packet);
      socket.close();
    } catch (UnknownHostException exception) {

    } catch (SocketException exception) {

    } catch (IOException exception) {

    }
  }

}
