package com.zanichelli.android.geotracker;

import android.content.Intent;

public class GeoTrackerActivity extends PermissionCompatActivity {

  // notifica alla classe GeoTrackerApplication di essere
  // la activity correntemente attiva tra quelle della APP
  @Override
  public void onStart() {
    super.onStart();
    GeoTrackerApplication app = (GeoTrackerApplication) getApplication();
    app.setCurrentActivity(this);
  }

  // metodo invocato quando il service che riceve
  // aggiornamenti GPS cambia il suo stato
  // da attivo a inattivo e viceversa
  public void onServiceStatusChanged() {

  }

  @Override
  public void onPermissionDenied(int requestCode) {
    super.onPermissionDenied(requestCode);

    // cancella una eventuale
    // esecuzione pendente
    LocationService.cancelPendingrequest();
  }

  // metodo invocato quando una richiesta di un permesso
  // è terminata con esito positivo
  @Override
  public void onPermissionGranted(int requestCode) {
    super.onPermissionGranted(requestCode);

    // avvia nuovamente il service se l'esecuzione
    // precedente era stata terminata per la mancanza
    // del permesso necessario
    if (LocationService.hasPendingRequest())
      startService(new Intent(this, LocationService.class));
  }
}
