package com.zanichelli.android.geotracker.position;

/**
 * Created by Gabriele Ara on 04/12/2016.
 */

public class Date {

  private int day;  // Giorno
  private int month;  // Mese
  private int year;  // Anno

  // Calcola il numero giuliano (giorni trascorsi
  // dal 1 Gennaio 4713 a.C.) di una data
  private int julianNumber(Date d) {
    int c, y, m;

    c = (14 - d.getMonth()) / 12;
    y = d.getYear() + 4800 - c;
    m = d.getMonth() + 12 * c - 3;

    return d.getDay() + (153 * m + 2) / 5 + 365 * y + y / 4 - y / 100 + y / 400 - 32045;
  }

  public Date() {
    day = 1;
    month = 1;
    year = 2000;
  }

  public Date(Date d) {
    day = d.getDay();
    month = d.getMonth();
    year = d.getYear();
  }

  public Date(int d, int m, int y) {
    this();

    if (y < 1 || m < 1 || m > 12 || d < 1) {
      return;
    }

    if (m == 1 || m == 3 || m == 5 || m == 7 || m == 8 || m == 10 || m == 12) {
      if (d > 31) {
        return;
      }
    }

    if (m == 4 || m == 6 || m == 9 || m == 11) {
      if (d > 30) {
        return;
      }
    }

    // TODO: Non è mica vero
    if (m == 2 && y % 4 == 0) // Anno bisestile
    {
      if (d > 29) {
        return;
      }
    }

    if (m == 2 && y % 4 != 0) // Anno non bisestile
    {
      if (d > 28) {
        return;
      }
    }

    year = y;
    month = m;
    day = d;
  }

  //Ex.: s = "Tue Oct 08 11:44:52 CEST 2013"
  public Date(String s) {
    String arr[] = s.split(" ");
    year = Integer.parseInt(arr[5]);

    switch(arr[1]) {
      case "Jan":
        month = 1;
        break;
      case "Feb":
        month = 2;
        break;
      case "Mar":
        month = 3;
        break;
      case "Apr":
        month = 4;
        break;
      case "May":
        month = 5;
        break;
      case "Jun":
        month = 6;
        break;
      case "Jul":
        month = 7;
        break;
      case "Aug":
        month = 8;
        break;
      case "Sep":
        month = 9;
        break;
      case "Oct":
        month = 10;
        break;
      case "Nov":
        month = 11;
        break;
      case "Dec":
        month = 12;
        break;
    }

    day = Integer.parseInt(arr[2]);
  }

  public int getDay() {
    return day;
  }

  public int getMonth() {
    return month;
  }

  public int getYear() {
    return year;
  }

  // Calcola la differenza in giorni da
  //  una data (negativo se precedente)
  public int dayDifference(Date d) {
    int my_jn, jn;

    my_jn = julianNumber(this);
    jn = julianNumber(d);

    return (jn - my_jn);
  }
}