package com.zanichelli.android.geotracker.position;

/**
 * Created by Gabriele Ara on 04/12/2016.
 */

public class Latitude {

  public static final int NORTH = 1;
  public static final int SOUTH = -1;

  private int orientation;    // -1 => Sud, +1 => Nord
  private int degree;         // Gradi
  private int minute;         // Primi
  private int second;         // Secondi

  public Latitude() {
    degree = 0;
    minute = 0;
    second = 0;
    orientation = NORTH;
  }

  public Latitude(Latitude l) {
    degree = l.getDegree();
    minute = l.getMinute();
    second = l.getSecond();
    orientation = l.getOrientation();
  }

  public Latitude(double l) {
    this();
    if (Math.abs(l) == 0.)
      return;

    orientation = (int) (l / Math.abs(l));
    l = Math.abs(l);
    //degree = (int) Math.ceil(l);
    degree = (int) l;
    l = (l - degree) * 60;

    //minute = (int) Math.ceil(l);
    minute = (int) l;
    second = (int) ((l - minute) * 60);
  }

  public Latitude(int d, int m, int s, int o) {
    this();

    if (d <= 89 && m <= 59 && s <= 59) {
      degree = d;
      minute = m;
      second = s;
    } else {
      if (d == 90 && m == 0 && s == 0) {
        degree = d;
        minute = 0;
        second = 0;
      } else {
        return;
      }
    }
    if (o >= 0) {
      orientation = +1;
    } else {
      orientation = -1;
    }
  }

  public int getOrientation() {
    return orientation;
  }

  public int getDegree() {
    return degree;
  }

  public int getMinute() {
    return minute;
  }

  public int getSecond() {
    return second;
  }

  // Latitudine in formato decimale
  // (positiva per Nord, negativa per Sud)
  public double getLatitude() {
    double latitude = (double) degree + (double) minute / 60. + (double) second / 3600.;
    if (orientation < 0) {
      return (-latitude);
    } else {
      return latitude;
    }
  }
}
