package com.zanichelli.android.geotracker.position;

/**
 * Created by Gabriele Ara on 04/12/2016.
 */

public class Longitude {

  public static final int EAST = 1;
  public static final int WEST = -1;

  private int orientation;    // -1 => West, +1 => Est
  private int degree;         // gradi
  private int minute;         // primi
  private int second;         // secondi

  public Longitude() {
    degree = 0;
    minute = 0;
    second = 0;
    orientation = EAST;
  }

  public Longitude(Longitude l) {
    degree = l.getDegree();
    minute = l.getMinute();
    second = l.getSecond();
    orientation = l.getOrientation();
  }

  public Longitude(double l) {
    this();
    if (Math.abs(l) == 0.)
      return;

    orientation = (int) (l / Math.abs(l));
    l = Math.abs(l);

    //degree = (int) Math.ceil(l);
    degree = (int) l;
    l = (l - degree) * 60;

    //minute = (int) Math.ceil(l);
    minute = (int) l;
    second = (int) ((l - minute) * 60);

  }

  public Longitude(int d, int m, int s, int o) {
    this();

    if (d <= 179 && m <= 59 && s <= 59) {
      degree = d;
      minute = m;
      second = s;
    } else {
      if (d == 180 && m == 0 && s == 0) {
        degree = d;
        minute = 0;
        second = 0;
      } else {
        return;
      }
    }
    if (o >= 0) {
      orientation = +1;
    } else {
      orientation = -1;
    }
  }

  public int getOrientation() {
    return orientation;
  }

  public int getDegree() {
    return degree;
  }

  public int getMinute() {
    return minute;
  }

  public int getSecond() {
    return second;
  }

  // Longitudine in formato decimale (positiva
  // per Est, negativa per Ovest)
  public double getLongitude() {
    double longitude = (double) degree + (double) minute / 60. + (double) second / 3600.;

    if (orientation < 0) {
      return (-longitude);
    } else {
      return longitude;
    }
  }
}
