package com.zanichelli.android.geotracker.position;

/**
 * Created by Gabriele Ara on 04/12/2016.
 */

public class Time {

  private int hour;  // Ore
  private int minute;  // Minuti
  private int second;  // Secondi

  public Time() {
    hour = 0;
    minute = 0;
    second = 0;
  }

  public Time(Time t) {
    hour = t.getHour();
    minute = t.getMinute();
    second = t.getSecond();
  }

  public Time(int h, int m, int s) {
    this();

    if (h > 23) {
      return;
    }
    if (m > 59) {
      return;
    }
    if (s > 59) {
      return;
    }
    hour = h;
    minute = m;
    second = s;
  }

  //Ex. s = "Tue Oct 08 11:44:52 CEST 2013"
  public Time(String s) {
    String arr[] = s.split(" ");
    String time = arr[3];

    String tme[] = time.split(":");

    hour = Integer.parseInt(tme[0]);
    minute = Integer.parseInt(tme[1]);
    second = Integer.parseInt(tme[2]);

  }

  public int getHour() {
    return hour;
  }

  public int getMinute() {
    return minute;
  }

  public int getSecond() {
    return second;
  }

  // Calcola la differenza in ore da
  // un orario (negativo se precedente)
  double hourDifference(Time t) {
    double my_decimal_hour, decimal_hour;

    my_decimal_hour = (double) hour + (double) minute / 60. + (double) second / 3600.;
    decimal_hour = (double) t.hour + (double) t.minute / 60. + (double) t.second / 3600.;

    return (decimal_hour - my_decimal_hour);
  }
}
